// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <mutex>
#include <iostream>

using namespace std;

std::once_flag flag1;

class MySingleton
{
private:
    static MySingleton* _inst;
    static std::once_flag _flag1;

    static MySingleton* getInstance()
    {
        std::call_once(_flag1, 
            []() { _inst = new MySingleton(); });

        return _inst;
    }
};

void print_out()
{
    std::cout << "Simple example: called once\n";
}

int main()
{
    std::call_once(flag1, print_out);
    std::call_once(flag1, print_out);

    return 0;
}

